package ocl2ac.test.performance.run.Rules;

import java.util.List;
import java.util.Random;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.henshin.interpreter.Match;
import org.eclipse.emf.henshin.interpreter.UnitApplication;
import org.eclipse.emf.henshin.model.HenshinFactory;

import MagicDrawStatechartsEffective.MagicDrawStatechartsEffectivePackage;
import nas.core.NasEMFManager;
import nas.core.NasHenshinManager;
import ocl2ac.configure.Configure;

/**
 * 
 * @author Nassarn (Nebras Nassar)
 *
 */
public class RunTest_Rule01 {

	static MagicDrawStatechartsEffectivePackage ePackageInstance = MagicDrawStatechartsEffectivePackage.eINSTANCE;

	private static final String NEW_TARGET = "NewTarget";
	private static final String SELECTED = "Selected";

	public static final String RULENAME = "addToConnectionPointReference_entry_Pseudostate";
	public static String INSTANCE_FILE_PATH_NAME = null;
	public static EObject root = null;
	public static String printInfo = null;
	public static long exeTime = 0;
	public static boolean applicable;

	public static void main(String[] args) {
		printInfo = null;
		exeTime = 0;

		// Load the model
		if (root == null) {
			if (INSTANCE_FILE_PATH_NAME == null)
				INSTANCE_FILE_PATH_NAME = Configure.INSTANCEFILEPATHNAME_10096;
			Resource resource = NasEMFManager.loadModel(INSTANCE_FILE_PATH_NAME, ePackageInstance);
			root = (EObject) resource.getContents().get(0);
		}

		// Get model size
		int size = NasHenshinManager.getModelSize(root);
	
		// Prepare the Henshin interpreter
		UnitApplication unitApplication = NasHenshinManager.prepareUnitApplication(Configure.HENSHINFILEPATHNAME_RULE01,
				RULENAME, root);

		List<Match> lhsMatches = NasHenshinManager.getLHSMatches(Configure.HENSHINFILEPATHNAME_RULE01, RULENAME, root);
		Random r = new Random();
		int low = 0;
		int high = lhsMatches.size();
		int i = r.nextInt(high - low) + low;
		unitApplication.setParameterValue(SELECTED,
				lhsMatches.get(i).getParameterValue(HenshinFactory.eINSTANCE.createParameter(SELECTED)));
		unitApplication.setParameterValue(NEW_TARGET,
				lhsMatches.get(i).getParameterValue(HenshinFactory.eINSTANCE.createParameter(NEW_TARGET)));

		// Apply the original rule
		long rule01_start = System.currentTimeMillis();
		applicable = unitApplication.execute(null);
		long rule01_stop = System.currentTimeMillis();

		// Calculate the needed time
		exeTime = rule01_stop - rule01_start;
		System.out.println("- The rule application took: " + exeTime + " ms");
		}

}
